/*  HEAPWALK.C
 *  last mod.: 6-OCT-91
 */

#include <STDIO.H>
#include <STDLIB.H>
#include <STRING.H>
#include <L_MEM.H>

char msg[70];

/*-----------*/
void main(void)
{
Uint block_number = 0;
int err_flag;
Far_ptr ptr = (Far_ptr)NULL;
struct block_info_t block_info;

printf("\nblock   block address     size      process ID");
while ( TRUE )
    {
    ptr = next_memory_block(ptr,&block_info,&err_flag);
    if ( err_flag )
        {
        printf("\n%s\n",mem_err_msg(err_flag,msg));
        exit(1);
        }
    if ( ptr == (Far_ptr)NULL )
        {
        printf("\n  End of heap\n");
        exit(0);
        }
    printf("\n%4u      %Fp     ",
        block_number++,ptr);
    printf("0x%06lX      ",block_info.size);
    if ( block_info.process_id > 0x100 )
        printf("0x%04X    ",block_info.process_id);
    else
        printf("          ");
    switch ( block_info.type )
        {
        case 0:  printf("free         "); break;
        case 1:  printf("program      "); break;
        case 2:  printf("environment  "); break;
        default:
            if ( block_info.process_id > 0x100 )
                printf("data         ");
        }
    if ( block_info.name[0] )
        printf("%s",block_info.name);
    }
}
